diff --git a/src/gui/Main.cpp b/src/gui/Main.cpp
index bdd81906..7f15a2da 100644
--- a/src/gui/Main.cpp
+++ b/src/gui/Main.cpp
@@ -30,24 +30,29 @@
 #include <Module.hpp>
 #include <IPC.hpp>
 
-#include <QCommandLineParser>
-#include <QVersionNumber>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QCommandLineParser>
+#endif
+// Qt4: No QVersionNumber (added in Qt5.6)
 #include <QApplication>
 #include <QImageReader>
 #include <QTreeWidget>
 #include <QMessageBox>
 #include <QFileDialog>
 #include <QPainter>
-#include <QWindow>
-#include <QScreen>
+// Qt4: No QWindow, use QWidget
+#include <QWidget>
+// Qt4: QScreen APIs are in QDesktopWidget
+#include <QDesktopWidget>
 #include <QBuffer>
 #include <QFile>
 #include <QDir>
 #ifdef CHECK_FOR_EGL
     #include <QLibrary>
 #endif
-#if defined(CHECK_FOR_EGL) || defined(Q_OS_MACOS)
-    #include <QSurfaceFormat>
+#if defined(CHECK_FOR_EGL) || defined(Q_OS_MAC)
+    // Qt4: Use QGLFormat instead of QSurfaceFormat
+    #include <QtOpenGL/QGLFormat>
 #endif
 
 #ifdef Q_OS_WIN
@@ -77,10 +82,10 @@ QString QMPlay2GUIClass::getPipe()
     wchar_t userName[UNLEN + 1];
     DWORD bufferSize = UNLEN + 1;
     if (GetUserNameW(userName, &bufferSize) && bufferSize > 1)
-        userNameSuffix = QStringLiteral(".") + QString::fromWCharArray(userName, bufferSize - 1);
+        userNameSuffix = QString(".") + QString::fromWCharArray(userName, bufferSize - 1);
 
-    return QStringLiteral("\\\\.\\pipe\\QMPlay2") + userNameSuffix;
-#elif defined Q_OS_MACOS
+    return QString("\\\\.\\pipe\\QMPlay2") + userNameSuffix;
+#elif defined Q_OS_MAC
     return "/tmp/QMPlay2." + QString(getenv("USER"));
 #else
     return QDir::tempPath() + "/QMPlay2." + QString(getenv("USER"));
@@ -120,7 +125,14 @@ void QMPlay2GUIClass::setTreeWidgetItemIcon(QTreeWidgetItem *tWI, const QIcon &i
         if (!treeWidget)
             treeWidget = tWI->treeWidget();
         if (treeWidget)
+        {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             tWI->setData(column, Qt::DecorationRole, icon.pixmap(treeWidget->window()->windowHandle(), treeWidget->iconSize()));
+#else
+            // Qt4: Use basic pixmap without window handle
+            tWI->setData(column, Qt::DecorationRole, icon.pixmap(treeWidget->iconSize()));
+#endif
+        }
         else
             setDefaultIcon = true;
     }
@@ -151,19 +163,18 @@ void QMPlay2GUIClass::loadIcons()
 {
     deleteIcons();
 
-    if (QVersionNumber::fromString(qVersion()) >= QVersionNumber(6, 7, 0))
-    {
-        qmplay2Icon = new QIcon(":/QMPlay2.svgz");
-    }
-    else
-    {
-        // QtSvg doesn't support effects. This workaround generates drop shadow effect similar to
-        // drop shadow in SVG file. Remove / modify this workaround if QMPlay2 SVG icon changes!
-        const QSize size(128, 128);
-        const QPixmap pixmap = QIcon(":/QMPlay2.svgz").pixmap(size);
-        const qreal sizeRatio = (((qreal)pixmap.size().width()  / (qreal)size.width()) + ((qreal)pixmap.size().height() / (qreal)size.height())) / 2.0;
-        qmplay2Icon = new QIcon(Functions::applyDropShadow(pixmap, 10.0 * sizeRatio, QPointF(3.0 * sizeRatio, 3.0 * sizeRatio), QColor(0, 0, 0, 127)));
-    }
+    // Qt4: No QVersionNumber, use QT_VERSION macro instead
+    // Qt4/5 need drop shadow workaround, Qt6.7+ has it in SVG
+    #if QT_VERSION >= QT_VERSION_CHECK(6, 7, 0)
+    qmplay2Icon = new QIcon(":/QMPlay2.svgz");
+    #else
+    // QtSvg doesn't support effects. This workaround generates drop shadow effect similar to
+    // drop shadow in SVG file. Remove / modify this workaround if QMPlay2 SVG icon changes!
+    const QSize size(128, 128);
+    const QPixmap pixmap = QIcon(":/QMPlay2.svgz").pixmap(size);
+    const qreal sizeRatio = (((qreal)pixmap.size().width()  / (qreal)size.width()) + ((qreal)pixmap.size().height() / (qreal)size.height())) / 2.0;
+    qmplay2Icon = new QIcon(Functions::applyDropShadow(pixmap, 10.0 * sizeRatio, QPointF(3.0 * sizeRatio, 3.0 * sizeRatio), QColor(0, 0, 0, 127)));
+    #endif
 
     groupIcon = new QIcon(getIconFromTheme("folder-orange"));
     mediaIcon = new QIcon(getIconFromTheme("applications-multimedia"));
@@ -184,7 +195,11 @@ QString QMPlay2GUIClass::getCurrentPth(QString pth, bool leaveFilename)
         pth.remove(0, 7);
     if (!leaveFilename)
         pth = Functions::filePath(pth);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
     if (!QFileInfo::exists(pth))
+#else
+    if (!QFileInfo(pth).exists())
+#endif
     {
         pth = settings->getString("currPth");
 #ifdef Q_OS_ANDROID
@@ -201,6 +216,7 @@ void QMPlay2GUIClass::setCurrentPth(const QString &pth)
 
 void QMPlay2GUIClass::restoreGeometry(const QString &pth, QWidget *w, const int defaultSizePercent)
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto window = w->window()->windowHandle();
     if (Q_UNLIKELY(!window))
         return;
@@ -227,6 +243,26 @@ void QMPlay2GUIClass::restoreGeometry(const QString &pth, QWidget *w, const int
         w->move(screenSize.width() / 2 - defaultSize.width() / 2, screenSize.height() / 2 - defaultSize.height() / 2);
         w->resize(defaultSize);
     }
+#else
+    // Qt4: Use QDesktopWidget for screen geometry
+    const QRect geo = settings->getRect(pth);
+    const QDesktopWidget *desktop = QApplication::desktop();
+    const QRect screenGeo = desktop->screenGeometry(w);
+
+    if (geo.isValid())
+    {
+        w->setGeometry(geo);
+        if (!screenGeo.contains(w->pos()))
+            w->move(screenGeo.width() / 2 - w->width() / 2, screenGeo.height() / 2 - w->height() / 2);
+    }
+    else
+    {
+        const QRect availGeo = desktop->availableGeometry(w);
+        const QSize defaultSize = availGeo.size() * defaultSizePercent / 100;
+        w->move(screenGeo.width() / 2 - defaultSize.width() / 2, screenGeo.height() / 2 - defaultSize.height() / 2);
+        w->resize(defaultSize);
+    }
+#endif
 }
 
 void QMPlay2GUIClass::updateInDockW()
@@ -254,6 +290,18 @@ QMPlay2GUIClass::~QMPlay2GUIClass()
 
 /**/
 
+static QString fileArg(const QString &arg)
+{
+    if (!arg.contains("://"))
+    {
+        const QFileInfo argInfo(arg);
+        if (!argInfo.isAbsolute())
+            return argInfo.absoluteFilePath();
+    }
+    return arg;
+}
+
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
 static QCommandLineParser *createCmdParser(bool descriptions)
 {
     static constexpr const char *translations[] = {
@@ -304,7 +352,7 @@ static QCommandLineParser *createCmdParser(bool descriptions)
         {"next", maybeGetTranslatedText(translations[13])},
         {"prev", maybeGetTranslatedText(translations[14])},
         {"quit", maybeGetTranslatedText(translations[15])},
-#if !(defined Q_OS_MACOS || defined Q_OS_ANDROID)
+#if !(defined Q_OS_MAC || defined Q_OS_ANDROID)
         {"tray", maybeGetTranslatedText(translations[18])},
 #endif
         {{"h", "help"}, maybeGetTranslatedText(translations[16])},
@@ -312,23 +360,14 @@ static QCommandLineParser *createCmdParser(bool descriptions)
 
     return parser;
 }
-static QString fileArg(const QString &arg)
-{
-    if (!arg.contains("://"))
-    {
-        const QFileInfo argInfo(arg);
-        if (!argInfo.isAbsolute())
-            return argInfo.absoluteFilePath();
-    }
-    return arg;
-}
+
 static QList<QPair<QString, QString>> parseArguments(const QCommandLineParser &parser)
 {
     QList<QPair<QString, QString>> arguments;
     for (const QString &option : parser.optionNames())
     {
         QString value = parser.value(option);
-        if (option == QStringLiteral("open") || option == QStringLiteral("enqueue") || option == QStringLiteral("opennew"))
+        if (option == QString("open") || option == QString("enqueue") || option == QString("opennew"))
             value = fileArg(value);
         arguments += {option, value};
     }
@@ -342,7 +381,7 @@ static QList<QPair<QString, QString>> parseArguments(const QCommandLineParser &p
         bool found = false;
         for (int i = arguments.count() - 1; i >= 0; --i)
         {
-            if (arguments.at(i).first == QStringLiteral("open") || arguments.at(i).first == QStringLiteral("enqueue") || arguments.at(i).first == QStringLiteral("opennew"))
+            if (arguments.at(i).first == QString("open") || arguments.at(i).first == QString("enqueue") || arguments.at(i).first == QString("opennew"))
             {
                 arguments[i].second += "\n" + urlLines;
                 found = true;
@@ -355,6 +394,38 @@ static QList<QPair<QString, QString>> parseArguments(const QCommandLineParser &p
 
     return arguments;
 }
+#else
+// Qt4 fallback: Simple argument parsing
+static QList<QPair<QString, QString>> parseArguments()
+{
+    QList<QPair<QString, QString>> arguments;
+    const QStringList args = QCoreApplication::arguments();
+
+    for (int i = 1; i < args.count(); ++i)
+    {
+        const QString &arg = args.at(i);
+        if (arg.startsWith("--") || arg.startsWith("-"))
+        {
+            QString option = arg;
+            option.remove(QRegExp("^-+"));
+
+            QString value;
+            if (i + 1 < args.count() && !args.at(i + 1).startsWith("-"))
+            {
+                value = fileArg(args.at(++i));
+            }
+            arguments += {option, value};
+        }
+        else
+        {
+            // Positional argument - treat as "open" command
+            arguments += {"open", fileArg(arg)};
+        }
+    }
+
+    return arguments;
+}
+#endif
 
 static bool writeToSocket(IPCSocket &socket, QList<QPair<QString, QString>> &arguments)
 {
@@ -494,15 +565,16 @@ static LRESULT CALLBACK MMKeysHookProc(int code, WPARAM wparam, LPARAM lparam)
 }
 #endif
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
 static QtMessageHandler g_defaultMsgHandler = nullptr;
 static QMutex g_messageHandlerMutex;
 static void messageHandler(QtMsgType type, const QMessageLogContext &context, const QString &message)
 {
-    if (qstrcmp(context.category, "qt.qpa.wayland") == 0 && message.endsWith(QStringLiteral("Please fix the transient parent of the popup.")))
+    if (qstrcmp(context.category, "qt.qpa.wayland") == 0 && message.endsWith(QString("Please fix the transient parent of the popup.")))
         return;
 
     bool skip = false;
-    if (message.startsWith(QStringLiteral("load glyph failed")))
+    if (message.startsWith(QString("load glyph failed")))
         skip = true;
 
     bool qmplay2Log = false;
@@ -547,13 +619,59 @@ static void messageHandler(QtMsgType type, const QMessageLogContext &context, co
 #endif
     }
 }
+#else
+// Qt4 version
+static QtMsgHandler g_defaultMsgHandler = nullptr;
+static QMutex g_messageHandlerMutex;
+static void messageHandler(QtMsgType type, const char *msg)
+{
+    QString message = QString::fromLocal8Bit(msg);
+
+    bool skip = false;
+    if (message.startsWith(QString("load glyph failed")))
+        skip = true;
+
+    bool qmplay2Log = false;
+    if (!skip && QCoreApplication::instance())
+    {
+        switch (type)
+        {
+            case QtWarningMsg:
+            case QtCriticalMsg:
+            case QtFatalMsg:
+                g_messageHandlerMutex.lock();
+                QMPlay2Core.logError(message, false);
+                g_messageHandlerMutex.unlock();
+                qmplay2Log = true;
+                break;
+            case QtDebugMsg:
+                // Qt4: No QtInfoMsg, only log debug messages
+                break;
+            default:
+                break;
+        }
+    }
+    if (!qmplay2Log)
+    {
+        if (g_defaultMsgHandler)
+            g_defaultMsgHandler(type, msg);
+        else
+        {
+            g_messageHandlerMutex.lock();
+            fprintf(stderr, "%s\n", msg);
+            fflush(stderr);
+            g_messageHandlerMutex.unlock();
+        }
+    }
+}
+#endif
 
 #ifdef CHECK_FOR_EGL
 static void checkForEGL()
 {
     // FIXME: Non-X11 environment must also get the device file.
 
-    if (QGuiApplication::platformName() != "xcb")
+    if (QApplication::platformName() != "xcb")
         return;
 
     QLibrary libX11("libX11.so.6");
@@ -636,9 +754,10 @@ static void checkForEGL()
 
         if (!isMesa && isEgl)
         {
-            auto fmt = QSurfaceFormat::defaultFormat();
-            fmt.setRenderableType(QSurfaceFormat::OpenGLES);
-            QSurfaceFormat::setDefaultFormat(fmt);
+            // Qt4: Use QGLFormat instead of QSurfaceFormat for OpenGL ES
+            QGLFormat fmt = QGLFormat::defaultFormat();
+            fmt.setProfile(QGLFormat::NoProfile); // OpenGL ES doesn't use profiles
+            QGLFormat::setDefaultFormat(fmt);
         }
     }
 }
@@ -669,20 +788,30 @@ int main(int argc, char *argv[])
 #endif
 
 #ifdef Q_OS_ANDROID
-    QGuiApplication::setAttribute(Qt::AA_DontUseNativeMenuBar); // Doesn't work in Qt6 (bug)
+    // Qt4: Use QApplication instead of QGuiApplication
+    QApplication::setAttribute(Qt::AA_DontUseNativeMenuBar);
 #endif
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
-    QGuiApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
-#endif
+// Qt4: AA_EnableHighDpiScaling is Qt5.6+, not available in Qt4
+// High DPI not supported on macOS 10.6.8 anyway
+
 #ifndef USE_OPENGL
-    QGuiApplication::setAttribute(Qt::AA_ForceRasterWidgets);
+    // Qt4: AA_ForceRasterWidgets may not be available
+    #if defined(Qt::AA_ForceRasterWidgets)
+    QApplication::setAttribute(Qt::AA_ForceRasterWidgets);
+    #endif
 #endif
 
-#ifdef Q_OS_MACOS
-    auto fmt = QSurfaceFormat::defaultFormat();
-    fmt.setColorSpace(QSurfaceFormat::sRGBColorSpace);
-    QSurfaceFormat::setDefaultFormat(fmt);
+#ifdef Q_OS_MAC
+    // Qt4: Use QGLFormat instead of QSurfaceFormat
+    // sRGB color space handling for OpenGL 2.0
+    QGLFormat fmt = QGLFormat::defaultFormat();
+    fmt.setAlpha(true);
+    fmt.setDepth(false);
+    fmt.setStencil(false);
+    fmt.setDoubleBuffer(true);
+    fmt.setSwapInterval(1); // VSync
+    QGLFormat::setDefaultFormat(fmt);
 #endif
 
 #ifndef Q_OS_WIN
@@ -704,10 +833,15 @@ int main(int argc, char *argv[])
     QCoreApplication::setApplicationName("QMPlay2");
 
     QMPlay2GUIClass &qmplay2Gui = QMPlay2GUI; //Create "QMPlay2GUI" instance
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     g_defaultMsgHandler = qInstallMessageHandler(messageHandler);
+#else
+    g_defaultMsgHandler = qInstallMsgHandler(messageHandler);
+#endif
 
     g_qAppOK = true;
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QCommandLineParser *parser = createCmdParser(false);
     parser->setSingleDashWordOptionMode(QCommandLineParser::ParseAsLongOptions);
     parser->process(*qApp);
@@ -715,6 +849,19 @@ int main(int argc, char *argv[])
     const bool help = parser->isSet("help");
     QString cmdLineProfile = parser->value("profile");
     delete parser;
+#else
+    // Qt4 fallback
+    QList<QPair<QString, QString>> arguments = parseArguments();
+    bool help = false;
+    QString cmdLineProfile;
+    for (const auto &arg : arguments)
+    {
+        if (arg.first == "help" || arg.first == "h")
+            help = true;
+        if (arg.first == "profile")
+            cmdLineProfile = arg.second;
+    }
+#endif
 
     bool createPpipeInvoked = false;
 
@@ -745,7 +892,7 @@ int main(int argc, char *argv[])
                 argument.first = "open";
                 useSocket = false;
             }
-#if !(defined Q_OS_MACOS || defined Q_OS_ANDROID)
+#if !(defined Q_OS_MAC || defined Q_OS_ANDROID)
             else if (argument.first == "tray")
             {
                 startInvisible = true;
@@ -788,7 +935,7 @@ int main(int argc, char *argv[])
 
     QString libPath, sharePath = QCoreApplication::applicationDirPath();
     bool cmakeBuildFound = false;
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     if (QDir(sharePath).exists("../../../CMakeFiles/QMPlay2.dir"))
         sharePath += "/../../.."; //Probably CMake not-installed build in Bundle
 #endif
@@ -802,7 +949,7 @@ int main(int argc, char *argv[])
     }
     if (!cmakeBuildFound)
     {
-#if !defined Q_OS_WIN && !defined Q_OS_MACOS && !defined Q_OS_ANDROID && !defined Q_OS_HAIKU
+#if !defined Q_OS_WIN && !defined Q_OS_MAC && !defined Q_OS_ANDROID && !defined Q_OS_HAIKU
         sharePath = QCoreApplication::applicationDirPath() + "/../share/qmplay2";
         libPath = QMPlay2CoreClass::getLibDir();
         if (libPath.isEmpty() || !QDir(libPath).exists("qmplay2"))
@@ -816,7 +963,7 @@ int main(int argc, char *argv[])
                 libPath += "lib";
         }
         libPath += "/qmplay2";
-#elif defined Q_OS_MACOS
+#elif defined Q_OS_MAC
         libPath = QCoreApplication::applicationDirPath();
         sharePath += "/../share/qmplay2";
 #else
@@ -827,10 +974,12 @@ int main(int argc, char *argv[])
     qRegisterMetaType<AVRational>("AVRational");
     qRegisterMetaType<Demuxer *>("Demuxer*");
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
-    QGuiApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0) && QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+    QApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);
 #endif
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QApplication::setAttribute(Qt::AA_DontCreateNativeWidgetSiblings);
+#endif
 
     QDir::setCurrent(QCoreApplication::applicationDirPath()); //Is it really needed?
 
@@ -840,9 +989,9 @@ int main(int argc, char *argv[])
         QApplication::setQuitOnLastWindowClosed(false);
         PanGestureEventFilter::install();
 #ifdef Q_OS_WIN
-        auto font = QGuiApplication::font();
+        auto font = QApplication::font();
         font.setHintingPreference(QFont::PreferVerticalHinting);
-        QGuiApplication::setFont(font);
+        QApplication::setFont(font);
 #endif
     }
 
@@ -859,11 +1008,23 @@ int main(int argc, char *argv[])
 
         if (help)
         {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             parser = createCmdParser(true);
             parser->setApplicationDescription(QString("QMPlay2 - Qt Media Player 2 (%1)").arg((QString)Version::get()));
             printf("%s", parser->helpText().toLocal8Bit().constData());
             fflush(stdout);
             delete parser;
+#else
+            // Qt4: Simple help text
+            printf("QMPlay2 - Qt Media Player 2 (%s)\n", Version::get().constData());
+            printf("Usage: qmplay2 [options] [url...]\n");
+            printf("Options:\n");
+            printf("  --open <url>       Open and play specified URL\n");
+            printf("  --enqueue <url>    Add specified URL to playlist\n");
+            printf("  --profile <name>   Start with given profile\n");
+            printf("  --help, -h         Display this help\n");
+            fflush(stdout);
+#endif
             break;
         }
 
diff --git a/src/gui/Main.hpp b/src/gui/Main.hpp
index a1646f00..550c7a66 100644
--- a/src/gui/Main.hpp
+++ b/src/gui/Main.hpp
@@ -35,7 +35,7 @@ class VideoDock;
 class MenuBar;
 class QWidget;
 
-class QMPlay2GUIClass final : private QMPlay2CoreClass
+class QMPlay2GUIClass : private QMPlay2CoreClass
 {
     Q_DECLARE_TR_FUNCTIONS(QMPlay2GUIClass)
 
@@ -68,8 +68,8 @@ public:
 
     void updateInDockW();
 
-    QWidget *getVideoDock() const override;
-    QWidget *getMainWindow() const override;
+    QWidget *getVideoDock() const;
+    QWidget *getMainWindow() const;
 
     QColor grad1, grad2, qmpTxt;
     QIcon *groupIcon, *mediaIcon, *folderIcon;
